package org.jeecg.modules.stm.act.collection.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;


import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.jeecg.modules.stm.act.collection.entity.StCaMainRelCollection;
import org.jeecg.modules.stm.act.collection.service.IStCaMainRelCollectionService;
import org.jeecg.modules.stm.act.collection.vo.CaRelCollectionVo;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import java.util.Arrays;

/**
 * @Description: st_ca_main_rel_collection
 * @Author: yzh
 * @Date:   2023-03-22
 * @Version: V1.0
 */

@RestController
@RequestMapping("/act.collection/stCaMainRelCollection")
@Slf4j
public class StCaMainRelCollectionController extends JeecgController<StCaMainRelCollection, IStCaMainRelCollectionService> {
	@Autowired
	private IStCaMainRelCollectionService stCaMainRelCollectionService;
	
	/**
	 * 分页列表查询
	 *
	 * @param stCaMainRelCollection
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "st_ca_main_rel_collection-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<StCaMainRelCollection>> queryPageList(StCaMainRelCollection stCaMainRelCollection,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<StCaMainRelCollection> queryWrapper = QueryGenerator.initQueryWrapper(stCaMainRelCollection, req.getParameterMap());
		Page<StCaMainRelCollection> page = new Page<StCaMainRelCollection>(pageNo, pageSize);
		IPage<StCaMainRelCollection> pageList = stCaMainRelCollectionService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	@AutoLog(value = "st_ca_main_rel_collection-添加")

	@RequiresPermissions("act.collection:st_ca_main_rel_collection:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody CaRelCollectionVo caRelCollectionVo) {
		stCaMainRelCollectionService.save(caRelCollectionVo);
		return Result.OK("添加成功！");
	}

	@AutoLog(value = "st_ca_main_rel_collection-添加")

	@RequiresPermissions("act.collection:st_ca_main_rel_collection:add")
	@PostMapping(value = "/addBycaIds")
	public Result<String> addBycaIds(@RequestBody CaRelCollectionVo caRelCollectionVo) {
		stCaMainRelCollectionService.addBycaIds(caRelCollectionVo);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param stCaMainRelCollection
	 * @return
	 */
	@AutoLog(value = "st_ca_main_rel_collection-编辑")

	@RequiresPermissions("act.collection:st_ca_main_rel_collection:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StCaMainRelCollection stCaMainRelCollection) {
		stCaMainRelCollectionService.updateById(stCaMainRelCollection);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "st_ca_main_rel_collection-通过id删除")
	@RequiresPermissions("act.collection:st_ca_main_rel_collection:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		stCaMainRelCollectionService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "st_ca_main_rel_collection-批量删除")

	@RequiresPermissions("act.collection:st_ca_main_rel_collection:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.stCaMainRelCollectionService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */

	@GetMapping(value = "/queryById")
	public Result<StCaMainRelCollection> queryById(@RequestParam(name="id",required=true) String id) {
		StCaMainRelCollection stCaMainRelCollection = stCaMainRelCollectionService.getById(id);
		if(stCaMainRelCollection==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stCaMainRelCollection);
	}

}
